<template>
  <div>
    <Toolbar :handle-submit="sendForm" :handle-delete="del" />
    <ProductForm
      ref="updateForm"
      v-if="itemToEdit"
      :values="itemToEdit"
      :errors="violations"
      :imageObjects="imageObjects"
      :productLoaded="productLoaded"
      v-on:on-images-changed="setImages"
      v-on:on-images-removed="removeImages"
    />
    <Loading :visible="isLoading || deleteLoading" />
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import { mapFields } from "vuex-map-fields";
import ProductForm from "../../../components/admin/product/Form.vue";
import Loading from "../../../components/Loading";
import Toolbar from "../../../components/Toolbar";
import UpdateMixin from "../../../mixins/UpdateMixin";

const servicePrefix = "Product";

export default {
  name: "ProductUpdate",
  servicePrefix,
  mixins: [UpdateMixin],
  components: {
    Loading,
    Toolbar,
    ProductForm
  },
  data() {
    return {
      imageObjects: [],
      itemToEdit: null,
      images: []
    };
  },
  computed: {
    ...mapFields("adminProduct", {
      deleteLoading: "isLoading",
      error: "error",
      updated: "updated",
      violations: "violations"
    }),
    ...mapFields("product", {
      itemProduct: "product",
      isLoading: "isLoading",
      uploadedImages: "uploadedImages",
      productLoaded: "productLoaded"
    }),
    ...mapGetters("adminProduct", ["find"])
  },
  created: function() {
    this.$nextTick(function() {
      this.getProduct(location.pathname.split("/")[3]);
      if (this.isLoading) {
        this.toggleLoading();
      }
    });
  },
  watch: {
    productLoaded(val) {
      if (val == true) {
        this.itemToEdit = this.itemProduct;
        if (this.itemToEdit.images.length > 0) {
          this.itemToEdit.images.forEach(image => {
            this.imageObjects.push(image);
          });
        }
      }
    }
  },
  methods: {
    ...mapActions("product", [
      "update",
      "getProduct",
      "uploadProductImages",
      "toggleLoading"
    ]),
    uploadImages: function() {
      if (this.images.length > 0) {
        this.images.forEach(image => {
          var formData = new FormData();
          formData.append("file", image, image.name);
          this.uploadProductImages(formData);
        });
      }
      if (!this.isLoading) var imagesArray = [];
      if (this.imageObjects.length > 0) {
        this.imageObjects.forEach(image => imagesArray.push(image["@id"]));
      }

      if (this.uploadedImages.length > 0) {
        this.uploadedImages.forEach(image => imagesArray.push(image));
      }

      this.update({ product: this.itemToEdit, images: imagesArray }).then(
        () => {
          this.showMessage("Élément modifié.");
          this.$router.push({ name: "AdminProductList" });
        }
      );
    },
    setImages(images) {
      this.images = images;
    },
    removeImages(imageObjects, toAddImages) {
      this.images = toAddImages;
      this.imageObjects = imageObjects;
    },
    sendForm() {
      this.uploadImages();
    }
  }
};
</script>
